Subject: Re: [PATCH net-next 1/2] net: add IP_DSCP_MASK

From: Guillaume Nault <[email-masked]>
Date: Mon, 3 Aug 2020 11:26:33 +0200

On Mon, Aug 03, 2020 at 04:02:16PM +0800, Hangbin Liu wrote:
> In RFC1349 it defined TOS field like
> 
>        0     1     2     3     4     5     6     7
>     +-----+-----+-----+-----+-----+-----+-----+-----+
>     |   PRECEDENCE    |          TOS          | MBZ |
>     +-----+-----+-----+-----+-----+-----+-----+-----+
> 
> But this has been obsoleted by RFC2474, and updated by RFC3168 later.
> Now the DS Field should be like
> 
>        0     1     2     3     4     5     6     7
>     +-----+-----+-----+-----+-----+-----+-----+-----+
>     |          DS FIELD, DSCP           | ECN FIELD |
>     +-----+-----+-----+-----+-----+-----+-----+-----+
> 
>       DSCP: differentiated services codepoint
>       ECN:  Explicit Congestion Notification
> 
> So the old IPTOS_TOS_MASK 0x1E should be updated. But since
> changed the value will break UAPI, let's add a new value
> IP_DSCP_MASK 0xFC as a replacement.
> 
> Signed-off-by: Hangbin Liu <[email-masked]>
> ---
>  include/uapi/linux/in_route.h | 1 +
>  include/uapi/linux/ip.h       | 2 ++
>  2 files changed, 3 insertions(+)
> 
> diff --git a/include/uapi/linux/in_route.h b/include/uapi/linux/in_route.h
> index 0cc2c23b47f8..26ba4efb054d 100644
> --- a/include/uapi/linux/in_route.h
> +++ b/include/uapi/linux/in_route.h
> @@ -29,5 +29,6 @@
>  #define RTCF_NAT	(RTCF_DNAT|RTCF_SNAT)
>  
>  #define RT_TOS(tos)	((tos)&IPTOS_TOS_MASK)
> +#define RT_DSCP(tos)	((tos)&IP_DSCP_MASK)
>  
>  #endif /* _LINUX_IN_ROUTE_H */
> diff --git a/include/uapi/linux/ip.h b/include/uapi/linux/ip.h
> index e42d13b55cf3..62e4169277eb 100644
> --- a/include/uapi/linux/ip.h
> +++ b/include/uapi/linux/ip.h
> @@ -22,6 +22,8 @@
>  
>  #define IPTOS_TOS_MASK		0x1E
>  #define IPTOS_TOS(tos)		((tos)&IPTOS_TOS_MASK)
> +#define IP_DSCP_MASK		0xFC
> +#define IP_DSCP(tos)		((tos)&IP_DSCP_MASK)

What's the use of IP_DSCP()? It's the same as RT_DSCP().

I guess it's supposed to be the equivalent of IPTOS_TOS(), but that
macro is only used once in the tree, where it could be replaced with
RT_TOS().

I can't see a reason to copy this pattern.